function love.load()

  cockpit = love.graphics.newImage("lib/cockpit.png")
  background = love.graphics.newImage("lib/background.jpg")

  love.graphics.setBackgroundColor(8,8,8)

end

local scene = {}
for i = 1, 350 do
  scene[i] = {
    x = math.random()*2 - 1;
    y = math.random()*2 - 1;
    z = -math.random()*2;
  }
end

function love.draw()
  
  love.graphics.draw(background, -300, -500)
  
  for _, vertex in pairs(scene) do
    if vertex.z < 0 then
      local x = vertex.x / -vertex.z
      local y = vertex.y / -vertex.z * -1

      x = 400 + x*400
      y = 300 + y*400

      love.graphics.setColor(255, 255, 236)
      love.graphics.circle("fill", x, y, 2/-vertex.z, 10)
    end
  end
  
  love.graphics.draw(cockpit, 0, 0)

end

function translate(x, y, z)
  for _, vertex in pairs(scene) do
    vertex.x = vertex.x + x
    vertex.y = vertex.y + y
    vertex.z = vertex.z + z
  end
end

function rotateY(r)
  local cosR = math.cos(r)
  local sinR = math.sin(r)
  for _, vertex in pairs(scene) do
    local x = vertex.x
    local z = vertex.z
    vertex.x = x*cosR + z*-sinR
    vertex.z = x*sinR + z*cosR
  end
end

function love.update(delta)
  local moveSpeed = delta 
  local rotSpeed = delta

  if love.keyboard.isDown("a") then
    translate(moveSpeed, 0, 0)
  end
  if love.keyboard.isDown("d") then
    translate(-moveSpeed, 0, 0)
  end

  if love.keyboard.isDown("w") then
    translate(0, 0, moveSpeed)
  end
  if love.keyboard.isDown("s") then
    translate(0, 0, -moveSpeed)
  end

  if love.keyboard.isDown("left") then
    rotateY(rotSpeed)
  end
  if love.keyboard.isDown("right") then
    rotateY(-rotSpeed)
  end

  if love.keyboard.isDown(" ") then
    translate(0, -moveSpeed, 0)
  end

  if love.keyboard.isDown("lshift") then
    translate(0, moveSpeed, 0)
  end

  if love.keyboard.isDown("escape") then
    love.event.quit()
  end

end